# Plan szkolenia GNU/Linux

## Prosta obsługa katalogów/plików

- Co się dzieje: `pwd`, `ls`
- Poruszanie się po FS: `cd`
- Modyfikacja plików/katalogów: `mkdir`, `touch`, `rm`, `cp`, `mv`
- Uprawnienia: `chmod`, `chown`
- Klawisz `tab` jako nasz przyjaciel
- `vim` - podstawy

## Programy/Aplikacje

- Jak to działa pod maską? Demo hello world w C++
- Argumenty: po co, konwencje (`-r` vs `--recursive`, etc.)
- Argumenty (z demo w C++)
- Przykłady: `wc`, `grep`, `sed`, `cat`, `echo`, `head`, `tail`, ...
- Archiwizacja: `tar`
- `--help` i `man`
- Znak specjalny '*'
- Przerywanie programów: `ctrl + c`
- Zmienne środowiskowe (z demo w C++)

## Skryptowanie

- Ogólna idea
- `#!/bin/bash`
- Zmienne
- `if`
- `for`
- Arytmetyka
- Potoki (z demo w C++)
- Potoki: dobre praktyki w stylu `./xyz.sh || exit 1'
- Przekierowania

## Praca z systemami zdalnymi

- `ssh`
- `scp`
- `rsync`
- `sftp`

## Demo workflow HPC

W oparciu o prostą bibliotekę w C++, którą napiszę na potrzeby szkolenia.
Matematycznie podstawy podstaw, żeby każdy zrozumiał (myślałem nad rozwiązywaniem funkcji kwadratowej, chociaż może wymyślę coś bardziej "kolorowego").
Nic skomplikowanego, `X.hpp` + `X.cpp` + `CMakeLists.txt`.

1. Lokalnie: przygotowanie pliku wsadowego (`vim`)
2. Wysłanie pliku wsadowego na topolę
3. Budowa kodu, bardzo prosta i schematyczna, tylko żeby zakomunikować, że w ogóle jest taki temat, coś w stylu
```bash
# install-app.sh
git clone X
mkdir -p X/build
cd X/build
module load apps/common/cmake/3.20
cmake --install-prefix ~/apps ..  || exit 1
cmake --build . || exit 1
cmake --install . || exit 1
cd ../..
rm -rf X

# ---
./install-app.sh > install.log
```
4. Utworzenie katalogu roboczego
5. Wywołanie zbudowanej aplikacji w katalogu roboczym na pliku wsadowym (z komentarzem, że normalnie robimy to przez system kolejkowy)
5. Zgranie wyników na maszynę lokalną
6. Postprocessing przy pomocy pythona (wykresy w Pyplocie - bez tłumaczenia samego narzędzia; dodatkowo komentarz, że w zależności od rozmiaru danych postprocessing może wymagać zasobów HPC)
