import numpy as np
import matplotlib.pyplot as plt
import argparse as argp
import sys

parser = argp.ArgumentParser(description='Postprocessing utility for quad-solver')
parser.add_argument('-o', help='Output file')
parser.add_argument('-f', help='Output file format')
args=parser.parse_args()

roots = np.zeros(0)
for line in sys.stdin:
  vals = line.replace('(', '').replace(')', '').split(',')
  real = float(vals[0])
  imag = float(vals[1])
  roots = np.append(roots, complex(real, imag))
    
for root in roots:
  plt.scatter(root.real, root.imag, marker='x', c='black')
plt.xlabel('Re')
plt.ylabel('Im')
plt.title('Root positions in complex plane')
plt.grid()
plt.savefig(args.o, format=args.f, bbox_inches='tight')
