#!/bin/bash

if ! [ -d "$1" ]; then
    echo "Please pass a valid source directory as the 1st argument"
    exit 1
fi

mkdir -p "$2" || (echo "Failed to create the destination directory specified in the 2nd argument" && exit 2)

if ! [ -x "$3" ]; then
    echo "Please pass a valid postprocessing python driver as the 3rd argument"
    exit 3
fi

src=$1
dest=$2
driver=$3

mkdir -p "$dest/logs"

for file in "$src"/*; do
    if [ -f "$file" ]; then
        echo Postprocessing "$file"...
        noextent="${file%.*}"
        name="${noextent##*/}"
        python3 "$driver" -o "$dest/$name.png" -f png < "$file" &> "$dest/logs/$name".log || (echo postprocessing failed && exit 4)
    fi
done
